<template>
  <template v-if="tree_item.concept && tree_item.children.length < 1"></template>
  <template v-else>
    <q-item
      @click="this.setAnchor(tree_item)"
      @keypress.enter="this.setAnchor(tree_item)"
      clickable
      v-if="label_in_search(tree_item)"
      :id="'item_' + tree_item.id"
      :class="add_class"
      :title="'Scroll naar ' + show_label(tree_item)"
      tabindex=0>
      <q-item-section>
        <q-item-label v-html="show_label(tree_item)"></q-item-label>
        <q-item-label caption>{{ tree_item.preferred_label }}</q-item-label>
      </q-item-section>
    </q-item>
    <q-list v-if="hasChildren" :class="add_padding">
      <TocTreeItem
        v-for="(child, index) in tree_item.children"
        :key="index"
        :tree_item="child"
        :search_value="search_value"
        :compact="compact"
        :level="level + 1">
        >
      </TocTreeItem>
    </q-list>
  </template>
</template>

<script>

import SharedMethods from "components/SharedMethods";
import _ from 'lodash'

export default {
  name: "TocTreeItem",
  created() {
    this.label_nice_role = SharedMethods.label_nice_role
    this.get_label = SharedMethods.get_label
    this.show_label = SharedMethods.show_label
  },
  computed: {
    hasChildren: function () {
      return this.tree_item.children && this.tree_item.children.length;
    },
    add_class: function () {
      let response = ''
      if ("#" + this.tree_item.id === this.$route.hash) {
        response = 'active '
      }
      if (this.tree_item.linkrole_id) {
        return response + 'linkrole'
      } else {
        return response + 'concept'
      }
    },
    add_padding: function () {
      if (!this.compact) {
        return 'pad-1'
      }
      return ''
    }
  },
  props: {
    search_value: String,
    tree_item: Object,
    level: undefined,
    compact: Boolean
  },
  methods: {
    setAnchor: function (item) {
      this.$router.push("#" + item.id)
    },
    label_in_search: function (item) {
      if (this.compact && item.node_type === "concept") {
        return false
      }
      if (!_.isUndefined(this.search_value) && this.search_value.length > 1) {
        return this.get_label(item).toLowerCase().includes(this.search_value.toLowerCase())
      }
      return true
    }
  }
}
</script>

<style scoped lang="scss">
.pad-1 {
  padding-left: 15px;
}

.linkrole {
  border-right: 2px solid $orange;
}

.active {
  background-color: $list_selected_bg;
  color: white;
  opacity: 0.9;
}

.active .no_label {
  color: black;
}

</style>
